# Оберон-У

Это реализация варианта языка **Оберон-7**. **Оберон-У** достаточносильно сильно отошёл от своего предка, но недостаточно, чтобы его считать самостоятельным языком.

С изменениями можно ознакомиться [здесь](./doc/lang_abstract.md).

Теоретически, программы на языке **Оберон-У** должны работать на следующих платформах:

```text
aix/ppc64        freebsd/amd64   linux/mipsle   openbsd/386
android/386      freebsd/arm     linux/ppc64    openbsd/amd64
android/amd64    illumos/amd64   linux/ppc64le  openbsd/arm
android/arm      js/wasm         linux/s390x    openbsd/arm64
android/arm64    linux/386       nacl/386       plan9/386
darwin/386       linux/amd64     nacl/amd64p32  plan9/amd64
darwin/amd64     linux/arm       nacl/arm       plan9/arm
darwin/arm       linux/arm64     netbsd/386     solaris/amd64
darwin/arm64     linux/mips      netbsd/amd64   windows/386
dragonfly/amd64  linux/mips64    netbsd/arm     windows/amd64
freebsd/386      linux/mips64le  netbsd/arm64   windows/arm
linux/risc       flatos/oberon-vcpu
```

Сборка и тестирование осуществляется только под **Linux**.

## Лицензия

Язык распространяется под лицензией **BSD-2** (делаем что хотим, авторов не забываем упомянуть, никаких гарантий).

## Статус

- [ ] Синтаксический парсер;
- [ ] Семантический парсер;
- [ ] Оптимизатор;
- [ ] Сборщик;

Структуру компилятора можно посмотреть [здесь](./doc/compiler.md)

## Цели сборки

Сборка рассчитана на утилиту `make` под **Linux**.

```bash
make           # Сборка под Linux
make build     # -//-
make win.build # Сборка под Windows
make dev.run   # Сборка и запуск для разработки
make mod       # обновление зависимостей
make lint      # Запуск линтеров
make test.run  # Запуск тестов
make graph     # Построение графа зависимостей в SVG
```
